package timer;

import javax.swing.*;

import java.awt.*;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.util.Timer;
import java.util.TimerTask;


public class timerPAF {
	public static void main(String[] args) {
		timerPAF programa = new timerPAF();
		programa.inicio();
	}

	public void inicio() {

		MarcoTimer marco = new MarcoTimer();
		marco.setDefaultCloseOperation(JFrame.EXIT_ON_CLOSE);

	}

	class MarcoTimer extends JFrame {

		public MarcoTimer() {
			setBounds(600,300,400,300);
			add(new LaminaMarcoTimer());
			setTitle("PAF Timer");
			setResizable(false);
			setVisible(true);

		}
	}

	class LaminaMarcoTimer extends JPanel {

		public LaminaMarcoTimer() {

			setLayout(new BorderLayout());

			superior = new JPanel();
			central = new JPanel();
			inferior = new JPanel();
			//Nombre Paf y horario
			String[][] examenes = {{"Programación UF2","60"},{"Programación UF3","50"}};

			font = new Font("Arial",Font.BOLD,20);

			combo = new JComboBox();
			for (int i=0; i<examenes.length;i++) {
				combo.addItem(examenes[i][0]);
			}

			tituloPAF = new JLabel("Asignatura : ");
			PAF = new JLabel("Asignatura");
			tituloTime = new JLabel("Tiempo que falta ");
			time = new JLabel("0");		

			combo.setFont(font);



			tituloPAF.setFont(font);
			PAF.setFont(font);
			tituloTime.setFont(font);

			combo.addActionListener(new ActionListener() {

				@Override
				public void actionPerformed(ActionEvent arg0) {

					//Solo actuamos en el timer si está inicializado
					if (timer != null)
						timer.cancel();
					
					for (int i=0; i<examenes.length;i++) {

						if(combo.getSelectedItem().equals(examenes[i][0])) {
							PAF.setText(examenes[i][0]);
							time.setText(examenes[i][1]);						
						}
					}
				}
			});

			empezar = new JButton("Empezar");
			detener = new JButton("Detener");

			time.setForeground(new Color(114, 183, 102));
			time.setFont(new Font("Arial",Font.BOLD,60));
			tituloPAF.setBounds(20, 10, 250, 50);
			PAF.setBounds(150, 10, 250, 50);
			tituloTime.setBounds(30, 70, 250, 50);
			time.setBounds(250, 70, 250, 50);

			superior.add(combo);
			central.add(tituloPAF);
			central.add(PAF);
			central.add(tituloTime);
			central.add(time);
			inferior.add(empezar);
			inferior.add(detener);

			add(superior,BorderLayout.NORTH);
			central.setLayout(null);
			add(central,BorderLayout.CENTER);
			add(inferior,BorderLayout.SOUTH);
			
			
			empezar.addActionListener(new actuarTimer());
			detener.addActionListener(new actuarTimer());

		}
		
		private class actuarTimer implements ActionListener {

			@Override
			public void actionPerformed(ActionEvent e) {
				// TODO Auto-generated method stub
				PAFText = PAF.getText();
				time.setForeground(new Color(114, 183, 102));
				if (e.getSource().equals(empezar)) {
										
					timer = new Timer();
					timer.scheduleAtFixedRate(new TimerTask() {
						
						int i = Integer.parseInt(time.getText());

						public void run() {		
														
							String minutesStr = String.valueOf(i);
							time.setText(minutesStr);
							i--;

							if(i<=5) {
								time.setForeground(Color.RED);
							}

							if (i < 0 ) {
								timer.cancel();
								time.setText("Fin");
							}
						}
					}, 0, 1000);

				} else {	
					timer.cancel();
					time.setText("Fin");	
				}
			}
		}

		Font font;
		JPanel superior,central, inferior;
		JLabel tituloPAF,PAF,tituloTime,time, horaInicio;
		JComboBox combo;
		JButton empezar, detener;
		private String PAFText;
		private int minutos;
		Timer timer;

	}

}


